PGraphics Perfil;
PGraphics Diagrama;
PGraphics Animacao;
PGraphics Inicio;
PGraphics Grains;

PImage backgnd;
PImage p_curve;
PImage subtitles;

int activeScreen = 0;
int cgrain;

void setup() {
  size(800, 600);
  backgnd = loadImage("back.jpg");
  
  // Imagens da tela inicial
  
  inicio = loadImage("textoinicio.png");
  subtitles = loadImage("sub.png");
  
  b_ani0 = loadImage("b_ani0.png");
  b_ani1 = loadImage("b_ani1.png");
  b_ani2 = loadImage("b_ani2.png");
  
  b_dia0 = loadImage("b_dia0.png");
  b_dia1 = loadImage("b_dia1.png");
  b_dia2 = loadImage("b_dia2.png");
  
  b_help0 = loadImage("b_help0.png");
  b_help1 = loadImage("b_help1.png");
  b_help2 = loadImage("b_help2.png");
  
  credits = loadImage("credits.png");
  
  b1 = loadImage("inicio_b1.png");
  b2 = loadImage("inicio_b2.png");
  
  // Imagens da parte do perfil
  
  p_curve = loadImage("curva.png");
  p_back = loadImage("p_back.png");
  
  b1_on = loadImage("b1_on.png");
  b1_off = loadImage("b1_off.png");
  b_temp = loadImage("b_temp.png");
  b_temp_on = loadImage("b_temp_on.png");
  
  b_reset0 = loadImage("b_reset0.png");
  b_reset1 = loadImage("b_reset1.png");
  b_reset2 = loadImage("b_reset2.png");
  
  t_ptoA = loadImage("ptoA.png");
  t_ptoB = loadImage("ptoB.png");
  t_liquidus = loadImage("liquidus.png");
  t_solidus = loadImage("solidus.png");
  
  verdana = loadFont("Verdana-12.vlw");
  
  // Imagens da animacao
  
  eixo = loadImage("eixo.png");
  tbox = loadImage("caixa1.png");
  tboxc = loadImage("caixac.png");
  balao = loadImage("balao_l.png");
  
  fwd = loadImage("fwd.png");
  bwd = loadImage("bwd.png");
  stp = loadImage("stp.png");
  
  for (int i = 0; i < exp_txt.length; i++)
    exp_txt[i] = loadImage("txt" + i + ".png");
  
  calibri = loadFont("Calibri-15.vlw");
  calibri10 = loadFont("Calibri-10.vlw");
  
  // Imagens do diagrama
  
  title = loadImage("title.png");
  
  diagrama = loadImage("diagrama.png");
  infobox = loadImage("info1.png");
  info_s = loadImage("info_s.png");
  
  drop = loadImage("drop.png");
  plus = loadImage("plus.png");
  adrop = loadImage("drop_active.png");
  sdrop = loadImage("drop_sel.png");
  aplus = loadImage("+_active.png");
  splus = loadImage("+_sel.png");
  xp = loadImage("xp.png");
  
  setad = loadImage("setad.png");
  setac = loadImage("setac.png");
  
  fade = loadImage("teste.png");
  pactive = loadImage("point_active.png");
  
  for (cgrain = 0; cgrain < grain.length; cgrain++)
    grain[cgrain] = loadImage("grain" + cgrain + ".png");
    
  cgrain = 0;
  
  me_screen = loadImage("canto1.png");
  me_mask = loadImage("me_mask.png");
  
  b_mod0 = loadImage("b_mod0.png");
  b_mod1 = loadImage("b_mod1.png");
  b_mod2 = loadImage("b_mod2.png");
  
  b_play0 = loadImage("b_play0.png");
  b_play1 = loadImage("b_play1.png");
  b_play2 = loadImage("b_play2.png");
  
  b_instruc0 = loadImage("b_instruc0.png");
  b_instruc1 = loadImage("b_instruc1.png");
  b_instruc2 = loadImage("b_instruc2.png");
  
  b_ti0 = loadImage("b_ti0.png");
  b_ti1 = loadImage("b_ti1.png");
  b_ti2 = loadImage("b_ti2.png");
  
    // Imagens da tela de ajuda
    
    scr_help = loadImage("scr_help.png");
  
  // Imagens da simulação
  
  text1 = loadImage("text1.png");
  text2 = loadImage("text2.png");
  text3 = loadImage("text3.png");
  text4 = loadImage("text4.png");
  text5 = loadImage("text5.png");
  box15 = loadImage("box15.png");
  
  goon0 = loadImage("goon0.png");
  goon1 = loadImage("goon1.png");
  
  // Novas imagens
  
  title_micro = loadImage("title_micro.png");
  
  // Graphics: completamente desnecessário [pra ESSE programa em particular]
  
  Perfil = createGraphics(800, 600, P2D);
  Diagrama = createGraphics(800, 600, P2D);
  Animacao = createGraphics(600, 400, P2D);
  Inicio = createGraphics(800, 600, P2D);
  
  smooth();
  noStroke();
}

void draw() {
  switch(activeScreen) {
    case 0: drawInicio(); break;
    case 1: drawAnimacao(); break;
    case 2: drawDiagrama(); break;
    case 3: drawPerfil(); break;
    case 4: drawCredits(); break;
    case 5: drawHelp(); break;
  //  image(Perfil, 110, 50);
  }
}

void mouseDragged() {
  
  // As somas aqui (195 e 160) é do translate que nao sei por que nao funciona pra posicao do mouse
  
  if (activeScreen == 3) {
     if (mouseX >= 220+195 && mouseX <= 386+195 && mouseY >= 20+160 && mouseY <= 219+160) {
       if (opcao == 1)
         y1anchor = mouseY-160;
       if (opcao == 2)
         y2anchor = mouseY-160;
       if (opcao == 3) {
         if (mouseX >= 220+195 && mouseX <= 303+195 && mouseY >= 20+160 && mouseY <= 219+160) {
           a1 = 1;
           a2 = 0;
           if (mouseX < x1+195 && mouseY < y1+160) {
             x3 = mouseX-195;
             y3 = mouseY-160;
           }
         }
         if (mouseX > 303+195 && mouseX <= 386+195 && mouseY >= 20+160 && mouseY <= 219+160) {
           a1 = 0;
           a2 = 1;
           if (mouseX < x2+195 && mouseY < y2+160) {
             x4 = mouseX-195;
             y4 = mouseY-160;
           }
         }
       }
       if (opcao == 4) {
         if (mouseX >= 220+195 && mouseX <= 303+195 && mouseY >= 20+160 && mouseY <= 219+160) {
           a1 = 1;
           a2 = 0;
           if (mouseX > x3+195 && mouseY > y3+160) {
             x1 = mouseX-195;
             y1 = mouseY-160;
           }
         }
         if (mouseX > 303+195 && mouseX <= 386+195 && mouseY >= 20+160 && mouseY <= 219+160) {
           a1 = 0;
           a2 = 1;
           if (mouseX > x4+195 && mouseY > y4+160) {
             x2 = mouseX-195;
             y2 = mouseY-160;
           }
         }
       }
     }
  }
  
  if (activeScreen == 2) {
    if (mouseX >= 100 && mouseX <= 431 && mouseY >= 100 && mouseY < 497 && lock_axis == 0) {
      p[activePoint].px = mouseX - 100;
      p[activePoint].py = mouseY - 100;
      alavanca();
    }
    
    // Controle dos pontos pelos eixos
    // Composicao
    
    if (mouseX >= 100 && mouseX <= 431 && mouseY >= 497 && mouseY <= 508) {
      lock_axis = 1;
      p[activePoint].px = mouseX - 100;
      alavanca();
    }
      
    // Temperatura  
    
    if (mouseX >= 89 && mouseX <= 100 && mouseY >= 100 && mouseY <= 497) {
      lock_axis = 1;
      p[activePoint].py = mouseY - 100;
      alavanca();
    }
  }
}

void mousePressed() {
  
  if (activeScreen == 4)
    if (mouseX > 673 && mouseX < 695 && mouseY > 55 && mouseY < 73)
      activeScreen = 0;
  
  if (activeScreen == 5)
    if (mouseX > 694 && mouseX < 716 && mouseY > 53 && mouseY < 71)
      activeScreen = 2;
  
  if (activeScreen == 0) {
    if (mouseX > 198 && mouseX < 324 && mouseY > 300 && mouseY < 337) {
     image(b_ani2, 199, 301);
     activeScreen = 1;
    }
     
     if (mouseX > 479 && mouseX < 605 && mouseY > 300 && mouseY < 337) {
       image(b_dia2, 479, 300);
       activeScreen = 2;
     }
     
     if (mouseX > 670 && mouseX < 795 && mouseY > 5 && mouseY < 41) {
       image(b_help2, 670, 5);
       activeScreen = 4;
     }
  }
  
  if (activeScreen == 1) {
    
      // Botao voltar
    
      if (mouseX > 640 && mouseX <= 654 && mouseY >= 97 && mouseY <= 116)
        back_ani();
      
      
      // Reset
      
      if (mouseX > 610 && mouseX <= 625 && mouseY >= 97 && mouseY <= 116 && trigger == 5) {
        reset();
      }
        
      // Botao de avançar
      
      if (mouseX > 670 && mouseX <= 684 && mouseY >= 97 && mouseY <= 116)
          forw_ani();
  
      if (mouseX > 640 && mouseX <= 661 && mouseY >= 102 && mouseY <= 119 && trigger == 5)
        trigger = 6;
      
      if (mouseX > 10 && mouseX < 110 && mouseY > 10 && mouseY < 40) {
        image(b_ti2, 10, 10);
        reset();
        activeScreen = 0;
      }
  }
  
  if (activeScreen == 2) {
    
    // Botao pra modificar a curva
    
    if (mouseX > 100 && mouseX < 168 && mouseY > 525 && mouseY < 553) {
      activeScreen = 3;
      image(b_mod2, 100, 525);
    }
    
    // Botão das instruções
    
    if (mouseX > 690 && mouseX < 790 && mouseY > 10 && mouseY < 40) {
      image(b_instruc2, 690, 10);
      activeScreen = 5;
    }
    
    if (mouseX > 10 && mouseX < 110 && mouseY > 10 && mouseY < 40) {
      image(b_ti2, 10, 10);
      activeScreen = 0;
    }
    
    // Botao de play da animação de resfriamento
    
    if (mouseX > textWidth("Explicação:") + 560 && mouseX < textWidth("Explicação:") + 589 && mouseY > 528 && mouseY < 551) {
      image(b_play2, textWidth("Explicação:") + 560, 528);
      py_temp = p[activePoint].py;
      p[activePoint].py = 0;
      simulacao = 1;
      iframe = 1;
    }
    
    // Sai da tela de escolha de pontos
    
    if (dropb == 1 && mouseX >= 550 && mouseX <= 721 && mouseY >= 267 && mouseY <= (267 + nPoint*27)) {
      if (mouseX >= 660 && mouseX <= 672 && mouseY >= 267 && mouseY <= (267 + nPoint*27)) {
        activePoint = int((mouseY - 240)/27) - 2;
        for (i = int((mouseY - 240)/27) - 1; i < 4; i++)
          p[i] = p[i+1];
        nPoint--;
      }
      else
        activePoint = int((mouseY - 240)/27) - 1;
      dropb = 0;
    }
    
    if (dropb == 1 && !(mouseX >= 550 && mouseX <= 721 && mouseY >= 267 && mouseY <= (267 + nPoint*27)))  
      dropb = 0;
    
    // Vai pra tela de escolha de pontos
    
    if (mouseX > 550 && mouseX < 684 && mouseY > 240 && mouseY < 267)
      dropb = 1;
      
    // Adiciona um novo ponto e define ele como ponto ativo
    
    if (mouseX > 697 && mouseX < 720 && mouseY > 240 && mouseY < 267 && nPoint < 5) {
      image(aplus, 550, 240);
      nPoint++;
      p[nPoint - 1] = new Pontos(0, 397, 0, 0);
      activePoint = nPoint - 1;
    }
    
    // Entrada de valores pras informações
    
    if (mouseX > 550 && mouseX < 721 && mouseY > 322.5+15 && mouseY < 337.5+15)
      info_in = 1;
    if (mouseX > 550 && mouseX < 721 && mouseY > 337.5+15 && mouseY < 352.5+15)
      info_in = 2;
    if (mouseX > 550 && mouseX < 721 && mouseY > 352.5+20 && mouseY < 367.5+20)
      info_in = 3;
    
    if (mouseX > 550 && mouseX < 721 && mouseY > 430 && mouseY < 445)
      info_in = 4;
    if (mouseX > 550 && mouseX < 721 && mouseY > 445 && mouseY < 460)
      info_in = 5;
  }
  
  if (activeScreen == 3) {
    if (dist(mouseX, mouseY, 221, 216) <= 8)
      opcao = 1;
    if (dist(mouseX, mouseY, 221, 236) <= 8)
      opcao = 2;
    if (dist(mouseX, mouseY, 221, 256) <= 8)
      opcao = 3;
    if (dist(mouseX, mouseY, 221, 276) <= 8)
      opcao = 4;
    
    // Botao de reset
    
    if (mouseX > 216 && mouseX <= 287 && mouseY >= 311 && mouseY <= 333) {
      image(b_reset2, 215, 310);
      y1anchor = 190;
      y2anchor = 70;
      x1 = 285; y1 = 155;
      x2 = 330; y2 = 130;
      x3 = 260; y3 = 110;
      x4 = 320; y4 = 85;
      temp1 = 1000;
      temp2 = 1600;
      tempm = 100;
    }
    
    // Botoes pra mudar os valores das temperaturas na escala
    
    if (mouseX > 187+195 && mouseX < 217+195 && mouseY > 213+160 && mouseY < 226+160)
      temp_input = 1;
    if (mouseX > 187+195 && mouseX < 217+195 && mouseY > 14+160 && mouseY < 27+160)
      temp_input = 2;
      
    if (mouseX > 581 && mouseX < 603 && mouseY > 154 && mouseY < 172)
      activeScreen = 2;
  }
  
  // Botoes de continuação da explicação
  
  if (activeScreen == 2 && simulacao == 1) {
    switch (iframe) {
      case 1: if (mouseX >= p[activePoint].px + text1.width - goon0.width + 223 && mouseX <= p[activePoint].px + text1.width + 100 && mouseY >= p[activePoint].py + text1.height - goon0.height + 100 && mouseY <= p[activePoint].py + text1.height + 100)
        iframe++; break;
      case 3: if (mouseX >= p[activePoint].px + text2.width - goon0.width + 223 && mouseX <= p[activePoint].px + text2.width + 100 && mouseY >= p[activePoint].py + text2.height - goon0.height + 100 && mouseY <= p[activePoint].py + text2.height + 100)
        iframe++; break;
      case 4: if (state == 2 && mouseX >= p[activePoint].px + text3.width - goon0.width + 223 && mouseX <= p[activePoint].px + text3.width + 100 && mouseY >= p[activePoint].py + text3.height - goon0.height + 100 && mouseY <= p[activePoint].py + text3.height + 100)
        iframe++; break;
      case 6: if (mouseX >= p[activePoint].px + text4.width - goon0.width + 223 && mouseX <= p[activePoint].px + text4.width + 100 && mouseY >= p[activePoint].py + text4.height - goon0.height + 100 && mouseY <= p[activePoint].py + text4.height + 100)
        iframe++; break;
      case 7: if (mouseX >= p[activePoint].px + text5.width - goon0.width + 223 && mouseX <= p[activePoint].px + text5.width + 100 && mouseY >= p[activePoint].py + text5.height - goon0.height + 100 && mouseY <= p[activePoint].py + text5.height + 100)
        iframe++; break;
    }
  }
  
}

void mouseReleased() {
  if (a1 == 1)
    a1 = 0;
  if (a2 == 1)
    a2 = 0;
    
  if (lock_axis == 1)
    lock_axis = 0;
}

void keyPressed() {
  
  if (activeScreen == 3) {
    if (temp_input == 1 || temp_input == 2) {
      if (key >= '0' && key <= '9'){
        input += char(key);
        if (abs(int(input)) > 10000 || abs(int(input)) < 0){
          input = input.substring(0, input.length()-1 ); 
        }
      }
      else if( key == BACKSPACE && input.length() > 0 )
        input = input.substring(  0, input.length()-1 );
      else if (key == RETURN || key == ENTER) {
        if (temp_input == 1 && int(input) < temp2)
          temp1 = int(input);
        if (temp_input == 2 && int(input) > temp1)
          temp2 = int(input);
        temp_input = 0;
        input = "";
        tempm = (temp2 - temp1)/6;
      }
    }
  }
  
  if (activeScreen == 2) {
      if (info_in != 3 && info_in != 0) {
        if (key >= '0' && key <= '9') {
          input += char(key);
          if (abs(int(input)) > 100 || abs(int(input)) < 0)
            input = input.substring(0, input.length()-1 ); 
        }
        else if( key == BACKSPACE && input.length() > 0 )
          input = input.substring(  0, input.length()-1 );
        else if (key == RETURN || key == ENTER) {
          switch(info_in) {
            case 1: p[activePoint].pc = 100 - float(input);
                    p[activePoint].px = 331*p[activePoint].pc/100;
                    info_in = 0;
                    input = "";
                    break;
            case 2: p[activePoint].pc = float(input);
                    p[activePoint].px = 331*p[activePoint].pc/100;
                    info_in = 0;
                    input = "";
                    break;
            case 4: wl = float(input)/100;
                    p[activePoint].px = -wl*(x_bezier2 - x_bezier) + x_bezier2;
                    info_in = 0;
                    input = "";
                    break;
            case 5: wl = 1 - float(input)/100;
                    p[activePoint].px = -wl*(x_bezier2 - x_bezier) + x_bezier2;
                    info_in = 0;
                    input = "";
                    break;
          }
        }
      }
      
      else {
        if (key >= '0' && key <= '9') {
          input += char(key);
          if (abs(int(input)) > temp2)
            input = input.substring(0, input.length()-1 );
        }
        else if( key == BACKSPACE && input.length() > 0 )
          input = input.substring(  0, input.length()-1 );
        else if (key == RETURN || key == ENTER) {
          if (abs(int(input)) < int(temp1) || abs(int(input)) > int(temp2)) {
            info_in = 0;
            input = "";
          }
          else {
            p[activePoint].pt = float(input);
            p[activePoint].py = (p[activePoint].pt - temp2)*(-397)/(temp2 - temp1);
            info_in = 0;
            input = "";
          }
        }
      }
      
//                                            if (key == CODED) {
//                                              if (keyCode == RIGHT)
//                                                cgrain++;
//                                              if (keyCode == LEFT)
//                                                cgrain--;
//                                            }
// Só liberar quando quiser posicionar os grãos
  }
  
  if (key == CODED) {
    if (activeScreen == 2 && keyCode == KeyEvent.VK_F1)
      activeScreen = 5;
  }
}

void reset() {
   for (i = 0; i < 11; i++) {
              x0[i] = x02[i];
              xf[i] = xf2[i];
              yf[i] = yf2[i];
              x2i[i] = x2i2[i];
              x2f[i] = x2f2[i];
              y2i[i] = y2i2[i];
            }
            for (i = 0; i < 9; i++)
              for (j = 0; j < 8; j++)
                curvas[i][j] = curvas2[i][j];
            y0 = y02;
            eixo_x = 432;
            pts = 0;
            
        cor = 0;
        timer = 0;
        
        for (i = 1; i < 9; i++)
                ani[i] = 0;
        
        timer_curvas = 0;
        fim = 0;
        
        trigger = 0; 
}
