float timer = 0;
float offset = 0.3;
int trigger = 0;
int i, j;
int v = 0;
int pts = 0;
int cor = 0;
float alfa = 0;
float eixo_x = 432;

int timer_curvas = 0;
float x_aux = 52, y_aux = 37;
float x_aux2 = 65, y_aux2;
float[] ani = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int fim = 0;

PImage eixo;
PImage tbox;
PImage tboxc;
PImage balao;
PImage fwd, bwd, stp;

PImage[] exp_txt = new PImage[15];

PFont calibri;
PFont calibri10;

  float[] x0 = { 40, 60, 80, 100, 120, 140, 160, 180, 200, 224, 240 };
  float y0 = 40;
  float[] xf = { 70, 84, 100, 115, 132, 149, 166, 184, 202, 221.5, 241 };
  float[] yf = { 160, 138, 120, 104, 89, 76, 65, 56, 50, 46, 42 };
  float[] x2i = { 80, 100, 123, 140, 162, 177, 196, 207, 218, 234, 252 };
  float[] x2f = { 95, 115, 140, 160, 185, 203, 225, 240, 255, 275, 295 };
  float[] y2i = { 160, 156, 149, 139, 128, 115, 102, 88, 74, 59, 44 };
  float[][] curvas = {  {84, 138, 90, 139, 97, 148, 100, 156}, {100, 120, 106, 121, 116, 125, 123, 149}, 
                      {115, 104, 121, 104, 136, 116, 140, 139}, {132, 89, 144, 89, 158, 105, 162, 128}, {149, 76, 157, 78, 171, 88, 177, 115},
                      {166, 65, 172, 67, 186, 67, 196, 102}, {184, 56, 190, 58, 200, 60, 207, 88}, {202, 50, 208, 50, 214, 54, 218, 74}, {221.5, 46, 225, 45, 231, 44, 234, 59} };
                      
  float[] x02 = { 40, 60, 80, 100, 120, 140, 160, 180, 200, 224, 240 };
  float y02 = 40;
  float[] xf2 = { 70, 84, 100, 115, 132, 149, 166, 184, 202, 221.5, 241 };
  float[] yf2 = { 160, 138, 120, 104, 89, 76, 65, 56, 50, 46, 42 };
  float[] x2i2 = { 80, 100, 123, 140, 162, 177, 196, 207, 218, 234, 252 };
  float[] x2f2 = { 95, 115, 140, 160, 185, 203, 225, 240, 255, 275, 295 };
  float[] y2i2 = { 160, 156, 149, 139, 128, 115, 102, 88, 74, 59, 44 };
  float[][] curvas2 = {  {84, 138, 90, 139, 97, 148, 100, 156}, {100, 120, 106, 121, 116, 125, 123, 149}, 
                      {115, 104, 121, 104, 136, 116, 140, 139}, {132, 89, 144, 89, 158, 105, 162, 128}, {149, 76, 157, 78, 171, 88, 177, 115},
                      {166, 65, 172, 67, 186, 67, 196, 102}, {184, 56, 190, 58, 200, 60, 207, 88}, {202, 50, 208, 50, 214, 54, 218, 74}, {221.5, 46, 225, 45, 231, 44, 234, 59} };

void drawAnimacao() {
  
  // Controladores do tempo. A cada frame add 1/frameRate ao timer
  // de forma que 1 segundo passa depois do n. de frames determinado
  
  background(backgnd);
  
  // Explicacao
  
  fill(100);
  textFont(verdana);
  textSize(10);
  
  image(tbox, 135, 30, 552, 90);
  
  if (trigger == 0)
    text("Clique na seta (>) para avançar na animação ou na seta (<) para voltar.", 150, 40, 525, 70);
  
  if (trigger == 1)
    text("Uma curva de resfriamento representa a temperatura em função do tempo durante o processo de solidificação de uma dada amostra. Curvas dessa natureza permitem a análise térmica do processo de solidificação.", 150, 40, 525, 70);
  
  if (trigger == 11) {
    image(exp_txt[0], 135, 30);
  }
  if (trigger == 21) {
    image(exp_txt[1], 135, 30);
  }
  
  if (trigger == 31) {
    image(exp_txt[2], 135, 30);
  }
   
  if (trigger == 41) {
    image(exp_txt[3], 135, 30);
    timer_curvas = 4;
    if (fim == 0) {
      x_aux = 52; y_aux = 37;
      x_aux2 = 65;
    }
  }
  
  if (trigger == 51) {
    text("É ilustrado o mesmo processo para as demais curvas. A última curva representa, assim como a primeira, um metal puro, porém com 100% de B. Condizentemente, a solidificação aqui também ocorre a temperatura constante.", 150, 40, 525, 80);
      x_aux = 72; y_aux = 37;
      x_aux2 = 260;
  }
  
  println(trigger);
  
  if (trigger == 2) {
    text("A região vermelha das curvas indica que o material se encontra integralmente no estado líquido, a região verde indica que as fases sólida e líquida do material coexistem e, finalmente, a região azul indica que o material se encontra integralmente no estado sólido.", 150, 40, 525, 70);
    timer += 1/frameRate;
  }
  
  if (trigger == 3)
    text("Agora será removida a dependência temporal das curvas. Isso significa que todas as curvas ficarão paralelas ao eixo das temperaturas, sendo caracterizadas, para cada composição, por suas temperaturas líquidus e solidus.", 150, 40, 525, 70);
    
  if (trigger == 4) {
    image(exp_txt[4], 135, 30);
    
  }
  
  if (trigger == 5) {
    image(exp_txt[14], 135, 30);
    
  }
 
  if (trigger > 0)
    image(bwd, 640, 97);
  
  if (trigger <= 6 || trigger > 10)
    image(fwd, 670, 97);
  
  pushMatrix();
  
  image(b_ti0, 10, 10);
  if (mouseX > 10 && mouseX < 110 && mouseY > 10 && mouseY < 40)
    image(b_ti1, 10, 10);
  
  translate(200, 180);
  
  // Eixo do tempo/composição
  
  image(eixo, 32, 0, eixo_x, 342);
  if (trigger == 4 && eixo_x > 350)
    eixo_x -= 4*offset;
  
  textFont(verdana);
  fill(0);
  
  if (trigger != 4 && trigger != 5)
    image(exp_txt[6], 110, -20);
//    text("Gráfico 1: Temperatura x Tempo", 235, -5);
  
  text("Temperatura", -3, 35);
  
  if (trigger < 4 || trigger > 10)
    text("Tempo", 430, 350);
  
  noFill();
  
  translate(-13, 0);
  
  // Composições
  
  if (trigger > 1 && trigger < 4 || trigger >= 21) {
      for (i = 60; i <= 360; i += 30) {
        if (i == 60)
          text(0, 50, 50);
        else
          text((i-60)/3, i, 50);
      }
    text("Composição (%B)", 210, 30);
  }
  
  if (trigger >= 4 && xf[10] >= x2i[10] && xf[0] >= x2i[0]) {
    for (i = 60; i <= 360; i += 30)
      text((i-60)/3, i, 350);
    text("Composição (%B)", 210, 370);
    text("A Puro", 20, 350);
    text("B Puro", 400, 350);
    if (y0 > 10)
      y0 -= offset;
  }
  
  // Mudança de cores do diagrama
  
  strokeWeight(1.5);
  stroke(255, 0, 0);
  if (trigger >= 4 && pts > 9)// || (trigger == 2 && cor != 1 && cor != 0))
    stroke(150);
    
  scale(1.5);
  
        // Desenho das curvas (retas de cima)
        
        if (trigger >= 2 && trigger <= 5 || trigger == 51) {
          for (i = 40; i <= 240; i += 20) {
            if (i == 220)
              i = 221;
            line(i, y0, xf[v], yf[v]);
            if (i == 221)
              i = 220;
            v++;
          }
        }
        
        // Desenho da primeira curva de resfriamento (metal puro)
        
        if (trigger == 31 && timer_curvas == 0) {
          
          line(40, y0, 40 + alfa*(xf[0]-40), y0 + alfa*(yf[0]-y0));
          alfa += 0.03;
          
          if (alfa >= 1.0) {
            timer_curvas = 1;
            alfa = 0.0;
          }
        }        
          
  // Tira o eixo do tempo (1)
  
  if (trigger == 4) {
    for (i = 0; i < 11 && xf[i] > x0[i]+0.5; i++)
        xf[i] -= offset;
  }
  v = 0;
  
  // Mudança de cores do diagrama
  
  stroke(0, 0, 255);
  if (trigger >= 4 && pts > 9) {  //|| (trigger == 2 && cor != 3 && cor != 0))
    stroke(150);
    pushMatrix();
    resetMatrix();
      image(exp_txt[5], 230, 159);
    popMatrix();
  }
  
  if (trigger == 4) {
    for (i = 0; i < 11; i++) {
      if (x2i[i] > xf[i])
        x2i[i] -= offset;   
      if (x2f[i] > x2i[i]+1)
        x2f[i] -= (x2f[i]-x2i[i])*offset;
    }
  }
  
          // Desenho das curvas (retas de baixo)
          
          if (trigger >= 2 && trigger <= 5 || trigger == 51)
            for (i = 0; i < 11; i++)
              line(x2i[i], y2i[i], x2f[i], 220);
              
          if (timer_curvas == 2) {
              stroke(255, 0, 0);
            line(40, y0, xf[0], yf[0]);
            
              stroke(0, 255, 0);
            line(xf[0], 160, x2i[0], 160);
            
              stroke(0, 0, 255);
            line(x2i[0], y2i[0], x2i[0] + alfa*(x2f[0] - x2i[0]), y2i[0] + alfa*(220 - y2i[0]));
            alfa += 0.03;
            
            if (alfa >= 1.0) {
              timer_curvas = 3;
              alfa = 0.0;
            }
          } 
  
  // Mudança de cores do diagrama
    stroke(0, 255, 0);
  if ((trigger >= 4 && pts > 9))
    stroke(0);
//  if (trigger == 2 && cor != 2 && cor != 0)
//    stroke(150);
  
          // Desenho das curvas (bezier)
          
          if (trigger >= 2 && trigger <= 5 || trigger == 51)
            for (i = 0; i < 9; i++)
                bezier(curvas[i][0], curvas[i][1], curvas[i][2], curvas[i][3], curvas[i][4], curvas[i][5], curvas[i][6], curvas[i][7]);
  
          // Desenho das curvas (retas do meio)
          
          if (trigger >= 2 && trigger <= 5 || trigger == 51) {
            line(xf[0], 160, x2i[0], 160);
            line(xf[10], 44, x2i[10], 44);
          }
          
          if (timer_curvas == 1) {
              stroke(255, 0, 0);
            line(40, y0, xf[0], yf[0]);
            
              stroke(0, 255, 0);
            line(xf[0], 160, xf[0] + alfa*(x2i[0] - xf[0]), 160);
            alfa += 0.08;
            
            if (alfa >= 1.0) {
              timer_curvas = 2;
              alfa = 0.0;
            }
          }
  
  if (trigger == 4) {
    for (i = 1; i < 10; i++) {
      if (curvas[i-1][0] > xf[i])
        curvas[i-1][0] -= offset;
      if (curvas[i-1][6] > x2i[i])
        curvas[i-1][6] -= offset;
      if (curvas[i-1][2] > x2i[i])
        curvas[i-1][2] -= offset;
      if (curvas[i-1][4] > x2i[i])
        curvas[i-1][4] -= offset;
      curvas[i-1][3] = curvas[i-1][5] = (yf[i] + y2i[i])/2;
    }
  }
  
  
  // Baloes de explicacao
  
  if (trigger >= 4 && xf[10] >= x2i[10] && xf[0] >= x2i[0]) {
    stroke(0);
    strokeWeight(1);
    
    // Desenho da linha liquidus; 'pts' é o contador das curvas
    // A cada frame desenha uma parte da reta até o ponto seguinte
    // Quando chega no ponto seguinte, o alfa é zerado, aumenta-se 'pts' e deixa
    // permanente a reta que foram criadas até o pts atual (o ultimo 'for')
    // Quando o alfa chega em 1, eu sei que a reta chegou no ponto final:
    // xf = x0 + alfa*(xf - x0)
    // yf = y0 + alfa*(yf - y0)    
    
    if (pts < 9) {
        line(xf[pts], yf[pts], xf[pts] + alfa*(xf[pts+1]-xf[pts]), yf[pts] + alfa*(yf[pts+1]-yf[pts]));
        alfa += 0.05;
    }
    
    if (pts == 9) {
      line(xf[pts], yf[pts], xf[pts] + alfa*(x2i[pts+1]-xf[pts]), yf[pts] + alfa*(y2i[pts+1]-yf[pts]));
      alfa += 0.01;
    }
    
    if (alfa >= 1.0) {
      alfa = 0.0;
      pts++;
    }
    
    // Desenho das linhas depois de traçadas
    
    // Mudança de cores do diagrama
    
    if (trigger >= 4 && pts > 9)
      stroke(255, 0, 0);
    
    for (i = 0; i < pts; i++) {
      if (i >= 9)
        line(xf[9], yf[9], x2i[10], y2i[10]);
      else
        line(xf[i], yf[i], xf[i+1], yf[i+1]);
    }
    
    // Desenho da linha solidus;
    
    if (pts < 10) {
        line(x2i[pts], y2i[pts], x2i[pts] + alfa*(x2i[pts+1]-x2i[pts]), y2i[pts] + alfa*(y2i[pts+1]-y2i[pts]));
        alfa += 0.01;
    }
    
    if (alfa >= 1.0) {
      alfa = 0.0;
      pts++;
    }
    
    // Mudança de cores do diagrama
    
    if (trigger >= 4 && pts > 9)
      stroke(0, 0, 255);
    
    for (i = 0; i < pts; i++)
        line(x2i[i], y2i[i], x2i[i+1], y2i[i+1]);
  }
  
  // Animação da segunda curva de resfriamento
  
  if (timer_curvas >= 3 && trigger < 51 && trigger > 10) {
      stroke(255, 0, 0);
    line(40, y0, xf[0], yf[0]);
    line(60, y0, xf[1], yf[1]);
    
      stroke(0, 255, 0);
    line(xf[0], 160, x2i[0], 160);
    bezier(curvas[0][0], curvas[0][1], curvas[0][2], curvas[0][3], curvas[0][4], curvas[0][5], curvas[0][6], curvas[0][7]);
    
      stroke(0, 0, 255);
    line(x2i[0], y2i[0], x2f[0], 220);
    line(x2i[1], y2i[1], x2f[1], 220);
    
      pushStyle();
        
        fill(255);
        noStroke();
        
        if (timer_curvas <= 3)
          quad(x_aux, y_aux, x_aux2 + 2, y_aux, 122, 221, 107, 221);
        
        if (timer_curvas == 4 && fim == 0) {
        
          if (alfa < 1.0) {
            quad(x_aux + alfa*(107 - x_aux), y_aux + alfa*(221 - y_aux), x_aux2 + 2 + alfa*(122 - x_aux), y_aux + alfa*(221 - y_aux), 122, 221, 107, 221);
            alfa += 0.01;
          }
          else {
            alfa = 0;
            timer_curvas = 5;
            fim = 1;
          }
        }
        
        fill(0);
        
      popStyle();
    
    // Texto da temp. de fusão
    
    if (timer_curvas == 3) {
      pushMatrix();
      
      pushStyle();
      
      stroke(0);
      strokeWeight(0.5);
      fill(0);
      line(-10, 160, 65, 160);
      ellipse(-10, 160, 2, 2);
      
      resetMatrix();
        image(exp_txt[8], 150, 400);
      
      popStyle();
      popMatrix();
    }

    if (fim == 1 && trigger == 41) {
      pushMatrix();
      
      pushStyle();
      
      stroke(0);
      strokeWeight(0.5);
      
      fill(0);
      line(-10, 138, 80, 138);
      ellipse(-10, 138, 2, 2);
      line(-10, 156, 96, 156);
      ellipse(-10, 156, 2, 2);
      
      resetMatrix();
        image(exp_txt[7], 120, 380);
        
      popStyle();
      
      popMatrix();
    }
    
  }
  
  // Animação das demais curvas
  
  if (trigger == 51) {
    
    pushStyle();
        
    fill(255);
    noStroke();
    
    for (i = 1; i < 9; i++) {
      
      if (ani[0] < 1.0) {
        quad(72 + ani[0]*(132 - 72), 37 + ani[0]*(221 - 37), 90 + ani[0]*(145 - 88),  37 + ani[0]*(221 - 37), 145, 221, 132, 221);
        ani[0] += 0.002;
      }
      
      if (ani[i] < 1.0) {
        quad(92 + ani[1]*(152 - 92), 37 + ani[1]*(219 - 37), 113 + ani[1]*(165 - 113),  37 + ani[1]*(219 - 37), 165, 221, 152, 221);
        quad(114 + ani[2]*(172 - 114), 37 + ani[2]*(219 - 37), 139 + ani[2]*(190 - 139),  37 + ani[2]*(219 - 37), 190, 221, 172, 221);
        quad(136 + ani[3]*(192 - 136), 37 + ani[3]*(219 - 37), 159 + ani[3]*(208 - 159),  37 + ani[3]*(219 - 37), 208, 221, 192, 221);
        quad(156 + ani[4]*(212 - 156), 37 + ani[4]*(219 - 37), 179 + ani[4]*(230 - 179),  37 + ani[4]*(219 - 37), 230, 221, 212, 221);
        quad(178 + ani[5]*(232 - 177), 37 + ani[5]*(219 - 37), 199 + ani[5]*(245 - 199),  37 + ani[5]*(219 - 37), 245, 221, 232, 221);
        quad(192 + ani[6]*(252 - 192), 37 + ani[6]*(219 - 37), 219 + ani[6]*(260 - 219),  37 + ani[6]*(219 - 37), 260, 221, 252, 221);
        quad(212 + ani[7]*(272 - 212), 37 + ani[7]*(219 - 37), 233 + ani[7]*(280 - 233),  37 + ani[7]*(219 - 37), 280, 221, 272, 221);
        quad(232 + ani[8]*(292 - 232), 37 + ani[8]*(219 - 37), 253 + ani[8]*(300 - 253),  37 + ani[8]*(219 - 37), 300, 221, 292, 221);
        if (ani[i-1] > 0.2 && i > 0)
          ani[i] += 0.01;
      }
    }
    
    popStyle();
  }
  
  
  popMatrix();
  
  pushMatrix();
  
    translate(200, 180);
    textFont(verdana);
    fill(0);
    
    if (trigger == 2) {
      if (timer > 2) {
//          image(tboxc, 80, 90, 80, 18);
//          text("Liquido", 80, 90, 80, 18);
          image(exp_txt[9], 80, 90);
          cor = 1;
      }
      if (timer > 4) {
//          image(tboxc, 170, 160, 98, 18);
//          text("Solido+Liquido", 170, 160, 98, 18);
          image(exp_txt[10], 160, 160);
          cor = 2;
      }
      if (timer > 6) {
//          image(tboxc, 280, 270, 80, 18);
//          text("Solido", 280, 270, 80, 18);
          image(exp_txt[11], 260, 240);
          cor = 3;
      }
    }
    
    if (trigger >= 4 && pts > 9) {
//      image(tboxc, 85, 95, 98, 18);
//      text("Linha Liquidus", 85, 95, 98, 18);
//      image(tboxc, 230, 210, 98, 18);
//      text("Linha Solidus", 230, 210, 98, 18);
        image(exp_txt[12], 85, 95);
        image(exp_txt[13], 210, 185);
    }
  
  popMatrix();
  println(eixo_x);
}

void back_ani() {
  switch(trigger) {
    case 0: trigger = 0; break;
    
    case 1: trigger--; break;
    
    case 11: trigger = 1; break;
    
    case 21: trigger -= 10; break;
    
    case 31: trigger -= 10;
              timer_curvas = 0; break;
              
    case 41: trigger -= 10;
              fim = 0;
              timer_curvas = 0; break;
              
    case 51: trigger -= 10; break;
    
    case 2: trigger = 51;
            for (i = 1; i < 9; i++)
                ani[i] = 0;  break;
                
    case 3: trigger--;
              timer = 0;
              cor = 0; break;
              
    case 4: trigger--;
            for (i = 0; i < 11; i++) {
              x0[i] = x02[i];
              xf[i] = xf2[i];
              yf[i] = yf2[i];
              x2i[i] = x2i2[i];
              x2f[i] = x2f2[i];
              y2i[i] = y2i2[i];
            }
            for (i = 0; i < 9; i++)
              for (j = 0; j < 8; j++)
                curvas[i][j] = curvas2[i][j];
            y0 = y02;
            eixo_x = 432;
            pts = 0;
            break;
            
     case 5: trigger--; break;
  }
}

void forw_ani() {
  switch(trigger) {
    case 0: trigger++; break;
    
    case 1: trigger = 11; break;
    
    case 11: trigger += 10; break;
    
    case 21: trigger += 10; break;
    
    case 31: trigger += 10; 
              timer_curvas = 0; break;
              
    case 41: trigger += 10;
              fim = 0;
              for (i = 0; i < 9; i++)
                ani[i] = 0;  break;
                
    case 51: trigger = 2;
              timer = 0;
              cor = 0; break;
              
    case 2: trigger++; break;
    
    case 3: trigger++;
             break;
            
    case 4: trigger++; break;
    
    case 5: activeScreen = 2; reset(); break;
  }
}
